function candoit = canGetEuclideanHessian(problem)
% Checks whether the Euclidean Hessian can be computed for a problem.
%
% function candoit = canGetEuclideanHessian(problem)
%
% Returns true if the Euclidean Hessian can be computed given the problem
% description, false otherwise.
%
% See also: canGetHessian getEuclideanGradient

% This file is part of Manopt: www.manopt.org.
% Original author: Nicolas Boumal, July 24, 2018.
% Contributors: 
% Change log: 


    candoit = isfield(problem, 'ehess');
    
end
